/*
 *	Census.h
 *
 *	Ideally, CCuspedCensus and CClosedCensus should have a common
 *	superclass which decompresses census manifolds from TRS# resources.
 *	Unfortunately, the Visual Architect doesn't handle "library
 *	classes" correctly, so as a workaround I've put the decompression
 *	code in Census.cp.
 *
 *	If, in a future version of the UI, it is again possible to
 *	use a superclass, consider the organization used in the old
 *	(pre Visual Architect) SnapPea:
 *
 *							CDirector
 *								|
 *						  CCensusDirector
 *						  /				\
 *			CCuspedCensusDirector	CClosedCensusDirector
 */


#include "SnapPea.h"

extern Triangulation	*GetCensusManifold(short aCensus, short anIndex, char* census_directory);
extern void				CreateCensusManifold(Triangulation *aTriangulation);
