#include "SnapPea.h"
#include "NathansSnapPea.h"



void ComputeHolonomy(
	Triangulation	*aTriangulation,
	int				anIndex,
	short			aFormat,
	Complex 		holonomy[])
{
	short			i;
	Complex			meridional_holonomy,
					longitudinal_holonomy;
	int				meridional_precision,
					longitudinal_precision;
	Complex			theLogHolonomy[2],
					theHolonomy,
					theComplexLength,
					theTraceSquared,
					theTrace,
					theEigenvalue,
					theValue[2];
	int				thePrecision[2];
	static Complex	one = { 1.0, 0.0},
					two = { 2.0, 0.0};

	switch (get_filled_solution_type(aTriangulation))
	{
		case geometric_solution:
		case nongeometric_solution:
		case flat_solution:
		case other_solution:

			get_holonomy(	aTriangulation,
							anIndex,
							&theLogHolonomy[0],
							&theLogHolonomy[1],
							&thePrecision[0],
							&thePrecision[1]);

			for (i = 0; i < 2; i++)
			{
				theComplexLength	= theLogHolonomy[i];
				theHolonomy			= complex_exp(theComplexLength);
				theTraceSquared		= complex_plus (
										complex_plus(
											theHolonomy,
											complex_div(one, theHolonomy)),
										two);
				theTrace			= complex_sqrt(theTraceSquared);
				theEigenvalue		= complex_exp(complex_real_mult(0.5, theComplexLength));

				switch (aFormat)
				{
					case 1: holonomy[i] = theComplexLength; break;
					case 2: holonomy[i] = theHolonomy;      break;
					case 3: holonomy[i] = theTrace;         break;
					case 4: holonomy[i] = theTraceSquared;  break;
					case 5: holonomy[i] = theEigenvalue;    break;
					default: uFatalError("Nathan's Compute Holonomy", "");
				}
			}

			break;

		case not_attempted:
		case degenerate_solution:
		case no_solution:
		default:
			uFatalError("Nathan's Compute Holonomy", "wrong solution type");
			break;
	}
}
