#
#  mcmullen.py
#

from SnapPea import *

# Script to divide the complements of links in S^3 into homeomorphism classes.

def main():
    for components in range(2, 6):   # Knots are dermined by their complement

        hom_equiv_classes = []

        # We are only going to do this for hyperbolic link complements

        for manifold in link_complements(components, 10):
            if manifold.complete_solution_type() != geometric_solution:
                continue

            already_seen = 0

            for equiv_class in hom_equiv_classes:
                if are_isometric(manifold, equiv_class[0]):
                    equiv_class.append(manifold)
                    already_seen = 1
                    break

            if not already_seen:
                hom_equiv_classes.append([manifold])

        # Done with main loop.  Print results.

        print "Components = %d" % components
        for equiv_class in hom_equiv_classes:
            if len(equiv_class) > 1:
                print equiv_class
        print

#---end main() -----------------

main()
            

#---------- program output -------------
#
#  Components = 2
#  [5^2_1, 7^2_8, 8^2_15, 9^2_47]
#  [6^2_3, 8^2_16, 9^2_45]
#  [7^2_3, 9^2_46]
#  [7^2_4, 9^2_44]
#  [7^2_5, 9^2_48]
#  [9^2_55, 9^2_56]
#  [9^2_59, 9^2_60]
#
#  Components = 3
#  [6^3_1, 8^3_8, 9^3_13, 9^3_17]
#  [6^3_2, 9^3_18]
#  [7^3_1, 9^3_14]
#  [8^3_9, 9^3_19]
#





        
