from SnapPea import *
import os, sys, re


# Returns a string containing a presentation of the given group in
# GAP format


def fp_group_to_GAP(G):
    o = "F := FreeGroup( "
    letters = G.gens()
    for letter in letters[:-1]:
        o = o +  '"' + letter + '", '
    o = o + '"' + letters[-1] + '");\n'
    for i in range(0, len(letters)):
        o = o + "%s := F.%d;;  %s := F.%s^-1;; " % (letters[i], i + 1, chr(ord(letters[i]) - 32) , i +1) 
        
    o = o +  "\nG := F / " 

    t = repr(G.relations())
    t = re.subn("\'", "")[0]
    t = re.subn("([a-zA-Z])([a-zA-Z])", lambda m: m.group(1) + "*" + m.group(2), t)[0]
    t = re.subn("([a-zA-Z])([a-zA-Z])", lambda m: m.group(1) + "*" + m.group(2), t)[0]
    o = o + t



m = get_manifold("m004(2,3)")
print fp_group_to_GAP(fundamental_group(m))



