from SnapPea import *
from shadow_class_modifications import *
import paths

def homology(arg0):
    val = SnapPeac.homology(arg0.this)
    val = AbelianGroupPtr(val)
    val.thisown = 1
    return val

def homology_from_fundamental_group(arg0):
    val = SnapPeac.homology_from_fundamental_group(arg0)
    val = AbelianGroupPtr(val)
    val.thisown = 1
    return val

def fundamental_group(arg0,arg1=1,arg2=1,arg3=1):
    val = SnapPeac.fundamental_group(arg0.this,arg1,arg2,arg3)
    val = GroupPresentationPtr(val)
    val.thisown = 1
    return val

def find_representations(arg0,arg1,arg2):
    val = SnapPeac.find_representations(arg0.this,arg1,arg2)
    val = RepresentationListPtr(val)
    val.thisown = 1
    return val

def copy_triangulation(arg0):
    val = SnapPeac.copy_triangulation(arg0.this)
    val = TriangulationPtr(val)
    val.thisown = 1
    return val

def wrapper_dual_curver_helper(dual_curve_raw_ptr):
    val = DualOneSkeletonCurve(dual_curve_raw_ptr)
    val.thisown = 1
    return val

def dual_curves(arg0, arg1):
    val = SnapPeac.dual_curves(arg0.this,arg1)
    val = DualOneSkeletonCurve
    
def find_normal_surfaces(arg0):
    val = SnapPeac.find_normal_surfaces(arg0.this)
    val = NormalSurfaceListPtr(val)
    val.thisown = 1
    list = []
    n = number_of_normal_surfaces_on_list(val)
    for i in range(n):
        list.append(NormalSurface(val, i))
    return list

def initialize_cusp_neighborhoods(arg0):
    val = SnapPeac.initialize_cusp_neighborhoods(arg0.this)
    val = CuspNeighborhoodsPtr(val)
    val.thisown = 1
    return val

def dual_curves(arg0,arg1):
    n, val = SnapPeac.dual_curves(arg0.this,arg1)
    val = DualOneSkeletonCurvePtrPtr (val, n, arg0)
    val.thisown = 1
    list = []
    for i in range(n):
        list.append(DualCurve(val, i))
    return list

def fibered_manifold_associated_to_braid(braid):
    n = max(map(abs, braid))+1
    word = ptrcreate("int", 0, len(braid))
    for i in range(len(braid)):
        ptrset(word, braid[i], i)
    val = SnapPeac.fibered_manifold_associated_to_braid(n, len(braid), word)
    ptrfree(word)
    val = TriangulationPtr(val)
    val.thisown = 1
    set_triangulation_name(val, "braid_manifold")
    return val

def fill_reasonable_cusps(*_args, **_kwargs):
    val = apply(SnapPeac.fill_reasonable_cusps,_args,_kwargs)
    if val: val = TriangulationPtr(val)
    val.thisown = 1
    return val

def GetCensusManifold(census_num, manifold_index):
    val = SnapPeac.GetCensusManifold(census_num, manifold_index, paths.trs_directory)
    if val:
        val = TriangulationPtr(val)
        val.thisown = 1
    return val






